<?php

// Provided By 
// Stephan Niebrgge <stephan.niebruegge@gmx.de>

// Adapted by Kasper Skrhj

// Substitutions:
// 		$value -> $conf["value"]
// 		$this->conf["special."] -> $conf
// 		$temp -> $menuItemsArray

	$altSortFieldValue = trim($this->mconf["alternativeSortingField"]);

			list($value)=t3lib_div::intExplode(",",$conf["value"]);
			if (!$value) {
				$value=$GLOBALS["TSFE"]->page[uid];
			}
			if ($conf["setKeywords"] || $conf["setKeywords."]) {
				$kw = $this->parent_cObj->stdWrap($conf["setKeywords"], $conf["setKeywords."]);
				} else {
					$value_rec=$this->sys_page->getPage($value);	// The page record of the "value".
				$kw = trim(tslib_cObj::keywords($value_rec["keywords"]));		// keywords.
				}

			$mode = $conf["mode"];	// *"auto", "manual", "tstamp"
			switch($mode)	{
				case "starttime":
					$sortField = "starttime";
				break;						
				case "lastUpdated":
				case "manual":
					$sortField = "lastUpdated";
				break;
				case "tstamp":
					$sortField = "tstamp";
				break;
				case "crdate":
					$sortField = "crdate";
				break;						
				default:
					$sortField = "SYS_LASTCHANGED";
				break;
			}

				// depth, limit, extra where
			if (t3lib_div::testInt($conf["depth"]))	{
				$depth = t3lib_div::intInRange($conf["depth"],0,20);		// Tree depth
			} else {
				$depth=20;
			}				
			$limit = t3lib_div::intInRange($conf["limit"],0,100);	// max number of items
			$extraWhere = " AND pages.uid!=".$value." AND pages.doktype!=5";
			if ($conf["excludeNoSearchPages"]) {
				$extraWhere.= " AND pages.no_search=0";
			}
				// start point
			$eLevel = tslib_cObj::getKey (intval($conf["entryLevel"]),$this->tmpl->rootLine);
			$startUid = intval($this->tmpl->rootLine[$eLevel][uid]);

				// which field is for keywords
			$kfield = "keywords";
			if ( $conf["keywordsField"] ) {
				list($kfield) = explode(" ",trim ($conf["keywordsField"]));
			}	
		
				// If there are keywords and the startuid is present.
//					debug($kw);
			if ($kw && $startUid)	{
				$bA = t3lib_div::intInRange($conf["beginAtLevel"],0,100);
				$id_list=tslib_cObj::getTreeList($startUid,$depth-1+$bA,$bA-1).($bA?0:$startUid);

				$kwArr = explode(",",$kw);
				reset($kwArr);
				while(list(,$word)=each($kwArr))	{
					$word = trim($word);
					if ($word)	{
						$keyWordsWhereArr[]=$kfield." LIKE '%".addslashes($word)."%'";
					}
				}
				$query = $GLOBALS["TSFE"]->cObj->getQuery("pages",Array("pidInList"=>"0", "uidInList"=>$id_list, "where"=>"(".implode($keyWordsWhereArr," OR ").")".$extraWhere, "orderBy"=>($altSortFieldValue ? $altSortFieldValue : $sortField." desc"),"max"=>$limit));
//Uncomment this					$res = mysql(TYPO3_db, $query);
//							while ($row = mysql_fetch_assoc($res))	{
//								$menuItemsArray[$row["uid"]]=$GLOBALS["TSFE"]->sys_page->getPageOverlay($row);
//							}
			}
//					break;
//Now the same as updated:	
			if ($value=="") {
				$value=$GLOBALS["TSFE"]->page[uid];
			}
			$items=t3lib_div::intExplode(",",$value);
			if (t3lib_div::testInt($conf["depth"]))	{
				$depth = t3lib_div::intInRange($conf["depth"],1,20);		// Tree depth
			} else {
				$depth=20;
			}				
			$limit = t3lib_div::intInRange($conf["limit"],0,100);	// max number of items
			$maxAge = intval(tslib_cObj::calc($conf["maxAge"]));
			if (!$limit)	$limit=10;
			$mode = $conf["mode"];	// *"auto", "manual", "tstamp"
				// Get id's
			$id_list_arr = Array();
			reset($items);
			while(list(,$id)=each($items))	{
				$bA = t3lib_div::intInRange($conf["beginAtLevel"],0,100);
				$id_list_arr[]=tslib_cObj::getTreeList($id,$depth-1+$bA,$bA-1).($bA?0:$id);
			}
			$id_list = implode($id_list_arr, ",");
				// Get sortField (mode)
			switch($mode)	{
				case "starttime":
					$sortField = "starttime";
				break;						
				case "lastUpdated":
				case "manual":
					$sortField = "lastUpdated";
				break;
				case "tstamp":
					$sortField = "tstamp";
				break;
				case "crdate":
					$sortField = "crdate";
				break;						
				default:
					$sortField = "SYS_LASTCHANGED";
				break;
			}
				// Get 
			$extraWhere = " AND pages.doktype!=5";

			if ($conf["excludeNoSearchPages"]) {
				$extraWhere.= " AND pages.no_search=0";
			}
			if ($maxAge>0)	{
				$extraWhere.=" AND ".$sortField.">".($GLOBALS["SIM_EXEC_TIME"]-$maxAge);
			}

// query from keywords - temporary:
$keywordWhere = $query;
if ($keywordWhere > '')
{
$keywordWhere = strstr($keywordWhere, 'uid');
$keywordWhere = ' OR (' . substr($keywordWhere,0,strpos($keywordWhere, 'AND pages.doktype')) . ')' ;
}	

			$query = $GLOBALS["TSFE"]->cObj->getQuery("pages",Array("pidInList"=>"0", "uidInList"=>$id_list, "where"=>$sortField.">=0".$extraWhere, "orderBy"=>($altSortFieldValue ? $altSortFieldValue : $sortField." desc"),"max"=>$limit));
// Now a combination from the keyword-query and update-query - this can be also in one line; but here I understand it better:
$query1 = substr($query,0,strpos($query, 'uid'));
$query2 = ' (';
$query3 = strstr($query, 'uid');
$query3 = '(' . substr($query3,0,strpos($query3, 'AND pages.doktype')) . ')';
$query4 = ') ';
$query5 = strstr($query, 'AND pages.doktype');
$query = $query1.$query2.$query3.$keywordWhere.$query4.$query5;



			$res = mysql(TYPO3_db, $query);
// How much entries in the array ?
$pieces = 0;

			while ($row = mysql_fetch_assoc($res))	{
				$menuItemsArray[$row["uid"]]=$GLOBALS["TSFE"]->sys_page->getPageOverlay($row);
$pieces = $pieces + 1;
			}
// Count of entries in the array:
$GLOBALS["TSFE"]->LISTUS=$pieces;

?>