<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

 
class alt_menu_functions {
	function mIconFile($Ifilename,$backPath)	{
		if (t3lib_div::isAbsPath($Ifilename))	{
			return $Ifilename;
		}
		return $backPath.$Ifilename;
	}
	function mIconFilename($Ifilename,$backPath)	{
		if (t3lib_div::isAbsPath($Ifilename))	{
			$Ifilename = "../".substr($Ifilename,strlen(PATH_site));
		}
	//	debug($backPath.$Ifilename);
		return $backPath.$Ifilename;
	}
	function topMenu($theModules,$dontLink=0,$backPath="",$descr=0)	{
		global $LANG, $TBE_TEMPLATE;
	
		$final="";
		$menuCode="";
		$descrCode="";
		$menuCode_sub="";
		$selectItems=array();
		$mIcons=array();
		$mJScmds=array();
		$onBlur=$GLOBALS["CLIENT"]["FORMSTYLE"] ? 'this.blur();' : '';
	
		$nlf_w = $GLOBALS["BE_USER"]->uc["navFrameWidth"];
		$selectItems[] = '<option value="">[ MODULES ]</option>';
		$mC=0;
	
		if ($GLOBALS["BE_USER"]->getTSConfigVal("options.disableDocModuleInAB"))	{
			unset($theModules["doc"]);
		}
	
		reset($theModules);
		while(list($moduleName,$moduleInfo)=each($theModules))	{
			$mC++;
			if ($moduleInfo!="spacer")	{
				switch($moduleName)	{
					case "web":
						$prefix="alt_db_frameset.php?w=".$nlf_w."&script=";
						if ($GLOBALS["BE_USER"]->uc["condensedMode"])	{
							$prefix="alt_db_navframe.php?currentSubScript=";
						}
					break;
					case "file":
						$prefix="alt_file_frameset.php?w=".$nlf_w."&script=";
						if ($GLOBALS["BE_USER"]->uc["condensedMode"])	{
							$prefix="alt_file_navframe.php?currentSubScript=";
						}
					break;
					case "doc":
						$prefix="";
					break;
					default:
						$prefix="";
					break;
				}
	
				if (is_array($moduleInfo["sub"]))	{
					if ($moduleInfo["defaultMod"])	{
						$link=$moduleInfo["sub"][$moduleInfo["defaultMod"]]["script"];
					} else {
						reset($moduleInfo["sub"]);
						$subTemp = current($moduleInfo["sub"]);
						$link=$subTemp["script"];
					}
					$link_sub=1;	// Tells that the main modules links to a submodule
					$link="";	// Does not link to submodules...
				} else {
					$link=$moduleInfo["script"];
					$link_sub=0;
				}
				
				$moduleKey = $moduleName."_tab";
				$image = @getimagesize($this->mIconFile($LANG->mainLang["tabs_images"][$moduleKey],$backPath));
				$imageCode="";
				$descr3_title = t3lib_BEfunc::titleAttrib($LANG->mainLang["tabs"][$moduleKey]);
				if ($image)	{
					$Ifilename = $this->mIconFilename($LANG->mainLang["tabs_images"][$moduleKey],$backPath);
					$imageCode = '<img src="'.$Ifilename.'" '.$image[3].' align=top>';
					$descr3_imageCode = '<img src="'.$Ifilename.'" '.$image[3].' align=top border=0'.$descr3_title.'>';
				} else {
					$descr3_imageCode = '<img src="'.$backPath.'gfx/dummy_module.gif" width="14" height="12" align=top border="0"'.$descr3_title.'>';
				}
				
				$label = $LANG->mainLang["tabs"][$moduleKey];
				$JScmd="this.selectedIndex=0;";
				if ($link && $prefix)	$link=$prefix.rawurlencode($link);
				if ($link && !$dontLink)	{
					$JScmd='parent.content.location=top.getModuleUrl(top.TS.PATH_typo3+\''.$this->wrapLinkWithAB($link).'\');';
					$label='<a href="#" onClick="top.goToModule(\''.$moduleName.'\');'.$onBlur.'return false;">'.$label.'</a>';	//  && !$link_sub
					$mIcons[]='<a href="#" onClick="top.goToModule(\''.$moduleName.'\');'.$onBlur.'return false;">'.$descr3_imageCode.'</a>';
					$mJScmds[]="case '".$moduleName."': \n ".$JScmd." \n break;";
				}
				$selectItems[] = '<option value="'.htmlspecialchars($JScmd).'">'.htmlspecialchars($LANG->mainLang["tabs"][$moduleKey]).'</option>';
				$label=fw("&nbsp;<b>".$label."</b>&nbsp;");
				
				$modItemCode=$imageCode.$label;
				$modItemCode='<table border=0 cellpadding=0 cellspacing=1 width="100%"><tr bgColor="#D9D9D8"><td>'.$modItemCode.'</td></tr></table>';
				$modItemCode='<tr><td colspan=3 bgColor="'.$TBE_TEMPLATE->bgColor2.'" nowrap>'.$modItemCode.'</td></tr>';
				$menuCode.=$modItemCode;
	
				$descrCode.='<tr><td colspan=3><img src=clear.gif width=1 height=10></td></tr>';
				$descrCode.='<tr><td colspan=3 bgColor="'.$TBE_TEMPLATE->bgColor4.'" nowrap>'.$imageCode.$label.'</td></tr>';
					// Travesing submodules
				$subCode="";
				if (is_array($moduleInfo["sub"]))	{
					reset($moduleInfo["sub"]);
					$c=0;
					while(list($subName,$subInfo)=each($moduleInfo["sub"]))	{
						if ($c==0)		$subCode.='<tr><td colspan=3><img src=clear.gif width=1 height=2></td></tr>';
	
						$link = $subInfo["script"];
						$subKey = $moduleName."_".$subName."_tab";
						$image = @getimagesize($this->mIconFile($LANG->mainLang["tabs_images"][$subKey],$backPath));
						$imageCode="";
						$descr3_title = t3lib_BEfunc::titleAttrib($LANG->mainLang["tabs"][$subKey].": ".$LANG->mainLang["labels"][$subKey."label"]);
						if ($image)	{
							$Ifilename = $this->mIconFilename($LANG->mainLang["tabs_images"][$subKey],$backPath);
							$imageCode = '<img src="'.$Ifilename.'" '.$image[3].t3lib_BEfunc::titleAttrib($LANG->mainLang["labels"][$subKey."label"]).'>';
							$descr3_imageCode = '<img src="'.$Ifilename.'" '.$image[3].' align=top border=0'.$descr3_title.'>';
						} else {
							$descr3_imageCode = '<img src="'.$backPath.'gfx/dummy_module.gif" width="14" height="12" align=top border="0"'.$descr3_title.'>';
						}
						
						$label = $LANG->mainLang["tabs"][$subKey];
						$label_descr = ' title="'.htmlspecialchars($LANG->mainLang["labels"][$subKey."label"]).'"';
						$flabel = fw($label);
						$origLink = $link;
						if ($link && $prefix)	$link=$prefix.rawurlencode($link);
						$addJS = "";
						if ($moduleName=="web")	{$addJS="+'&id='+top.theMenu.recentuid";}
						if ($moduleName=="file")	{$addJS="+'&id='+escape(parent.file_recent_id)";}
						if ($link && !$dontLink)	{
							if ($GLOBALS["AB"])	{
								if ($addJS && $GLOBALS["BE_USER"]->uc["condensedMode"])	{$addJS.=  "+(cMR?'&cMR=1':'')";}
								$JScmd = "parent.content.location=top.getModuleUrl(top.TS.PATH_typo3+'".$this->wrapLinkWithAB($link)."'".$addJS.");";
								if (!$GLOBALS["BE_USER"]->uc["condensedMode"] && ($moduleName=="web" || $moduleName=="file"))	{
									$tt=$moduleName=="web"?"db":"file";
										//	top.currentSubScript='".$this->wrapLinkWithAB($origLink)."';   is changed to     top.currentSubScript='".$origLink."';   090502
									$JScmd = "
										if (parent.content.".$tt."_list_frame) {
											top.currentSubScript='".$origLink."';
											parent.content.".$tt."_list_frame.location=top.getModuleUrl(top.TS.PATH_typo3+'".$this->wrapLinkWithAB($origLink)."'".$addJS.");
										} else {
											parent.content.location=top.TS.PATH_typo3+(
												top.nextLoadModuleUrl?
												'".($prefix?$this->wrapLinkWithAB($link)."&exScript=":"")."listframe_loader.html':
												'".$this->wrapLinkWithAB($link)."'".$addJS."
											);
										}";
								}
								$selectItems[] = '<option value="'.htmlspecialchars($JScmd).'">'.htmlspecialchars("- ".$label).'</option>';
								$flabel='<a href="#" onClick="top.goToModule(\''.$moduleName."_".$subName.'\');'.$onBlur.'return false;"'.$label_descr.'>'.fw($label).'</a>';
								$mIcons[]='<a href="#" onClick="top.goToModule(\''.$moduleName."_".$subName.'\');'.$onBlur.'return false;"'.$label_descr.'>'.$descr3_imageCode.'</a>';
								$mJScmds[]="case '".$moduleName."_".$subName."': \n ".$JScmd." \n break;";
							} else {
								$flabel='<a href="#" onClick="top.mods.modules[\''.$moduleName.'\'].currentSub=\''.$subName.'\';top.menuFaner.click(\''.$moduleName.'\');return false;"'.$label_descr.'>'.fw($label).'</a>';
							}
						} 
						
						
						
						$subCode.='<tr><td></td><td valign=top align=center>'.(!$GLOBALS["BE_USER"]->uc["hideSubmoduleIcons"]?$imageCode:"").'</td><td>'.$flabel.'</td></tr>';
	
						$descrCode.='<tr><td colspan=3><img src=clear.gif width=1 height=5></td></tr>';
						$descrCode.='<tr><td valign=top align=center>'.$imageCode.'</td><td valign=top nowrap>'.$flabel.'&nbsp;&nbsp;</td><td valign=top>'.fw("<strong>".$LANG->mainLang["labels"][$subKey."label"]."</strong><BR>".$LANG->mainLang["labels"][$subKey."descr"]).'</td></tr>';
	
						$c++;
						if ($c<count($moduleInfo["sub"]))	{
							$subCode.='<tr><td><img src=clear.gif width=5 height=1></td><td colspan=2><img src="gfx/altmenuline.gif" width="105" height="3"></td></tr>';
						} else {
							$subCode.='<tr><td colspan=3><img src=clear.gif width=1 height=4></td></tr>';
						}
					}
					if (count($theModules)>$mC)	$mIcons[]='<img src="'.$backPath.'gfx/acm_spacer2.gif" width="8" height="12" hspace=3 align=top>';
				} else {
					$subCode.='<tr><td colspan=3><img src=clear.gif width=1 height=2></td></tr>';
				}
	/*			if ($subCode)	{
					$subCode='<table border=0 cellpadding=1 cellspacing=1 width="100%">'.$subCode.'</table>';
					$subCode='<table border=0 cellpadding=1 cellspacing=1 bgColor="'.$TBE_TEMPLATE->bgColor2.'" width="100%"><tr><td>'.$subCode.'</td></tr></table>';
				}
	*/				// Adding submodule to module code.
	//			$menuCode.=$PB.'<td>'.$subCode.'</td>'.$PE;
				$menuCode.=$subCode;
			}
		}
		if ($menuCode)	{
			$final = '<table border=0 cellpadding=0 cellspacing=0 width=1>'.$menuCode.'</table>';
		}
		$descrCode = '<table border=0 cellpadding=0 cellspacing=0>'.$descrCode.'</table>';
		if ($descr==1)	{
			$final = $descrCode;
		}
		if ($descr==2)	{
			$selectItems[] = '<option value=""></option>';
			$selectItems[] = '<option value="'.htmlspecialchars("top.location='logout.php?redirect=index.php&ATBE=1&sendLogoutSignal=1';").'">[ LOGOUT ]</option>';
			$final = '<select name="menuselector" onChange="eval(this.options[this.selectedIndex].value);">'.implode("",$selectItems).'</select>';
		}
		if ($descr==3)	{
			$final = ''.implode("",$mIcons).'';
		}
		if ($descr==4)	{
			$final = chr(10).implode(chr(10),$mJScmds).chr(10);
		}
		return $final;
	}
	function topButtons()	{
		global $LANG, $TBE_TEMPLATE;
		$B = $LANG->printButtonsToJS(1);
	
	/*	// Clipboard:
		$img=$B["button_clipboard"];
		$image = @getimagesize($img);
		if ($image)	{
			$out.='<img src="'.$img.'" '.$image[3].' title="'.htmlspecialchars($LANG->mainLang["buttons"]["clipboard"]).'"><BR>';
		}
	*/
		// Logout:
		$img=$B["button_logout"];
		$image = @getimagesize($img);
		if ($image)	{
			$imgTag ='<img src="'.$img.'" '.$image[3].' title="'.htmlspecialchars($LANG->mainLang["buttons"]["logout"]).'" border=0><BR>';
			
			$out.= '<a href="logout.php?redirect=index.php&ATBE=1&sendLogoutSignal=1" target=_top>'.$imgTag.'</a>';
		}
		return $out;
	}
	function wrapLinkWithAB($link)	{
		if (strstr($link,"?"))	{
			return $link."&AB=1";
		} else {
			return $link."?AB=1";
		}
	}
}


if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["typo3/class.alt_menu_functions.inc"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["typo3/class.alt_menu_functions.inc"]);
}

?>