#
# Table structure for table 'sys_tabledescr'
#
CREATE TABLE sys_tabledescr (
  tablename varchar(40) DEFAULT '' NOT NULL,
  fieldname varchar(40) DEFAULT '' NOT NULL,
  description tinytext NOT NULL,
  details text NOT NULL,
  syntax text NOT NULL,
  image tinytext NOT NULL,
  image_descr tinytext NOT NULL,
  seeAlso text NOT NULL,
  serial int(11) DEFAULT '0' NOT NULL,
  tstamp int(11) DEFAULT '0' NOT NULL,
  PRIMARY KEY (tablename,fieldname)
);

#
# Table structure for table 'sys_tabledescr_dk'
#
CREATE TABLE sys_tabledescr_dk (
  tablename varchar(40) DEFAULT '' NOT NULL,
  fieldname varchar(40) DEFAULT '' NOT NULL,
  description_dk tinytext NOT NULL,
  details_dk text NOT NULL,
  syntax_dk text NOT NULL,
  image_descr_dk tinytext NOT NULL,
  serial_dk int(11) DEFAULT '0' NOT NULL,
  tstamp_dk int(11) DEFAULT '0' NOT NULL,
  PRIMARY KEY (tablename,fieldname)
);

#
# Table structure for table 'sys_tabledescr_local'
#
CREATE TABLE sys_tabledescr_local (
  tablename varchar(40) DEFAULT '' NOT NULL,
  fieldname varchar(40) DEFAULT '' NOT NULL,
  description tinytext NOT NULL,
  details text NOT NULL,
  syntax text NOT NULL,
  image_descr tinytext NOT NULL,
  serial int(11) DEFAULT '0' NOT NULL,
  tstamp int(11) DEFAULT '0' NOT NULL,
  image tinytext NOT NULL,
  seeAlso text NOT NULL,
  mode tinyint(4) DEFAULT '0' NOT NULL,
  PRIMARY KEY (tablename,fieldname)
);
