<?php

$LOCAL_LANG = Array (
	'default' => Array (
		'mlang_labels_tablabel' => 'Page content',
		'mlang_labels_tabdescr' => 'This module allows you to create and edit webpages. It provides a Quick-Editor for instant access to the primary page content. In addition you can manage different languages and columns of content per page. Finally you may access special page content like guestbook, board and shopping items. The module also presents pagehit statistics for the individual pages.',
		'mlang_tabs_tab' => 'Page',
	),
	'dk' => Array (
		'mlang_labels_tablabel' => 'Sideindhold',
		'mlang_labels_tabdescr' => 'Dette modul giver dig mulighed for at oprette og redigere websider. Kvik-redigerings-funktionen giver dig jeblikkelig adgang til det primre indhold p siderne. Herudover kan du styre forskellige sprog og kolonner per side. Endeligt kan du tilg specialiseret sideindhold s som gstebog-, forum- og produktelementer. Modulet fremviser ogs en sidevisningsstatestik for de enkelte sider.',
		'mlang_tabs_tab' => 'Side',
	),
	'de' => Array (
		'mlang_labels_tablabel' => 'Seiten-Info und Inhalt',
		'mlang_labels_tabdescr' => 'Mit diesem Modul knnen Sie neue Webseiten anlegen und bearbeiten. Es bietet einen Quickeditor fr schnellen Zugriff auf den Hauptseiteninhalt. Zustzlich knnen Sie verschiedene Sprachen und Inhaltsspalten Ihre Seite verwalten. Zustzlich knnen Sie speziellen Seiteninhalt wie Gstebcher-, Forums- und Shop-Eintrge verwalten. Das Modul zeigt Ihnen auch Seitenzugriffstatistiken fr die einzelnen Seiten an.',
		'mlang_tabs_tab' => 'Seite',
	),
	'no' => Array (
		'mlang_labels_tablabel' => 'Side-info og innhold',
		'mlang_labels_tabdescr' => 'Hurtigredigeringsfunksjonen gir deg rask tilgang til det primre innholdet p sidene. Du kan ogs velge forskjellige sprk og kolonner per side. Utover dette har du tilgang til spesielt sideinnhold som gjestebok-, forum- og produktelementer. Modulen viser ogs sidevisningsstatistikk for de enkelte sidene.',
		'mlang_tabs_tab' => 'Side',
	),
	'it' => Array (
		'mlang_labels_tablabel' => 'Contenuto della pagina',
		'mlang_labels_tabdescr' => 'Questo modulo permette di creare e editare le pagine. Fornisce un Quick-Editor per modificare velocemente il contenuto. Potete gestire i paragrafi in multilingua, su differenti colonne, e potete accedere a pagine di tipo speciale, come guestbook, forum di discussione, shopping. Attraverso questo modulo potete, infine, vedere alcune statistiche sulla pagina.',
		'mlang_tabs_tab' => 'Pagina',
	),
	'fr' => Array (
		'mlang_labels_tablabel' => 'Contenu page',
		'mlang_labels_tabdescr' => 'Ce modules vous permet de crer et d\'editer les pages web. Il vous apporte un Editeur rapide pour un accs immdiat au contenu primaire de la page. En plus, vous pouvez grer plusieurs langues et colone pour le contenu de la page. Finalement, vous pouvez accder au contenu spcial des pages comme les livres d\'or, les forums de discitions et le magasin en ligne. Ce module prsente aussi les statistiques pour chaque page.',
		'mlang_tabs_tab' => 'Page',
	),
	'es' => Array (
		'mlang_labels_tablabel' => 'Contenido de la pgina',
		'mlang_labels_tabdescr' => 'Este mdulo le permite crear y editar pginas web. Posee un Editor Rpido que facilita acceso instantneo al contenido primario de la pgina. Tambin puede administrar los diferentes lenguajes y columnas de contenido por pgina. Finalmente puede acceder a contenido especial como la lista de visitantes, el tablero de mensajes y los artculos de la tienda. El mdulo tambin muestra una estadstica de consulta de cada pgina individualmente.',
		'mlang_tabs_tab' => 'Pgina',
	),
	'nl' => Array (
		'mlang_labels_tablabel' => 'Pagina-inhoud',
		'mlang_labels_tabdescr' => 'Via deze module kan je webpagina\'s aanmaken en bewerken. Je vindt hier een Quick-Editor die je directe toegang geeft tot de primaire pagina-inhoud. Bovendien kan je de diverse talen en kolommen inhoud per pagina manipuleren. Tenslotte heb je toegang tot speciale pagina-inhoud zoals gastenboek, forum en winkelartikelen. Deze module introduceert ook statistieken van de pagina-treffers voor individuele pagina\'s.',
		'mlang_tabs_tab' => 'Pagina',
	),
	'cz' => Array (
		'mlang_labels_tablabel' => 'Obsah strany',
		'mlang_labels_tabdescr' => 'Tento modul umouje vytvet a editovat webov strnky. Poskytuje Quick-Editor pro okamit pstup k zkladnmu obsahu strany. Navc mete spravovat rzn jazyky a sloupce obsahu na stran. Navc mte pstupn i speciln obsah stran jako je nvtvn kniha, nstnka nebo zbo obchodu. Modul tak ukazuje statistiku pstup pro jednotliv strnky.',
		'mlang_tabs_tab' => 'Strana',
	),
	'pl' => Array (
		'mlang_labels_tablabel' => 'Zawarto strony',
		'mlang_labels_tabdescr' => 'Ten modu pozwala tworzy i edytowa strony. Do dyspozycji masz Szybki-Edytor do byskawicznej edycji treci zawartej na stronie. Moesz rwnie zarzdza treci w kolumnach oraz rnymi wersjami jzykowymi dla strony. Masz dostp rwnie do specjalnej zawartoci typu wpisy w forum dyskusyjnym, ksidze goci czy asortyment sklepu. Modu wywietla te statystyki odson dla poszczeglnych stron.',
		'mlang_tabs_tab' => 'Ukad',
	),
	'si' => Array (
		'mlang_labels_tablabel' => 'Vsebina strani',
		'mlang_labels_tabdescr' => 'Ta modul vam omogoa ustvarjanje in urejanje spletnih strani. Vsebuje hitri urejevalnik za takojnji dostop do primarne vsebine strani. Omogoa tudi upravljanje razlinih jezikovnih verzij strani. Lahko uporabite tudi posebno vsebino, naprimer knjigo gostov, oglasno desko, ali online trgovino. Tudi v tem modulu si lahko ogledate statistiko obiska strani.',
		'mlang_tabs_tab' => 'Stran',
	),
	'fi' => Array (
		'mlang_labels_tablabel' => 'Sivun sislt',
		'mlang_labels_tabdescr' => 'Tll modulilla luot, muotoilet ja yllpidt www-sivujasi. QuichEdit teksturilla ksittelet sivujen sislt. Lisksi voit hallita useita erikieli ja sarakkeita sivuillasi. Lisksi pset spesiaali sisltihin kuten esimerkiksi vieraskijaan, keskustelusivuille ja kauppasivuille. Moduli nytt mys sivuittain kytttilastot.',
		'mlang_tabs_tab' => 'Sivu',
	),
	'tr' => Array (
		'mlang_labels_tablabel' => 'Sayfa ierii',
		'mlang_labels_tabdescr' => 'Bu modl websayfalar yaratmanza ve dzenlemenize izin verir. Hzl Dzenleyici birincil sayfa ieriine acil eriim imkan salar. Buna ek olarak deiik dilleri ve her sayfa ieriinin stnlarn ynetebilirsiniz. Son olarak zel sayfa ieriine eriebilirsiniz ziyareti defteri, ilan tahtas ve alveri nesneleri gibi. Birde modl ksel sayfalar iin sayfa eriim istatistikleri sunuyor.',
		'mlang_tabs_tab' => 'Sayfa',
	),
	'se' => Array (
		'mlang_labels_tablabel' => 'Sidans innehll',
		'mlang_labels_tabdescr' => 'Med denna modul kan man skapa och ndra web-sidor. Hr finns en snabbeditering med vilken man snabbt kommer t det viktigaste sidinnehllet. Dessutom kan man vlja sprk och kolumner med innehll fr alla sidor. Slutligen kan man redigera olika slag av sidinnehll, t.ex. gstbok, diskussionsforum och produkter. Modulen presenterar ocks hur mnga trffar varje individuell sida ftt.',
		'mlang_tabs_tab' => 'Sida',
	),
	'pt' => Array (
		'mlang_labels_tablabel' => 'Contedo da pgina',
		'mlang_labels_tabdescr' => 'Este mdulo permite-lhe criar e editar pginas da internet. Providncia um Editor-Rpido para acesso instantneo ao contedo da pgina primria. Em adio pode gerir diferentes idiomas e colunas de contedo por pgina. Finalmente pode aceder a pginas de contedos especiais tais como livros de visitas, forum e items de loja. O mdulo tambm apresenta estatsticas de visualizao para pginas individuais.',
		'mlang_tabs_tab' => 'Pgina',
	),
	'ru' => Array (
		'mlang_labels_tablabel' => ' ',
		'mlang_labels_tabdescr' => '      -.             .                 .       ,    ,    .         .',
		'mlang_tabs_tab' => '',
	),
	'ro' => Array (
		'mlang_labels_tablabel' => 'Coninut de pagin',
		'mlang_labels_tabdescr' => 'Acest modul v permite s creai i s modificai pagini de web. Vi se ofer un editor pentru acces imediat la coninutul unei pagini. n completare, putei administra limbaje diferite i coloane de coninut n fiecare pagin. Mai putei crea pagini cu coninut special, cum ar fi cartea de oaspei, forum sau pagina de cumprturi. Acest modul prezint i statistici de accesare pentru fiecare pagin n parte.',
		'mlang_tabs_tab' => 'Pagin',
	),
	'ch' => Array (
	),
	'sk' => Array (
		'mlang_labels_tablabel' => 'Obsah strnky',
		'mlang_labels_tabdescr' => 'Tento modul umouje vytvra a pozmiea webov strnky. Poskytuje Quick-Editor na rchly prstup k zkladnmu obsahu strnky. Navia mete spravova rzne jazykov verzie a stpce na strnke. Nakoniec, mete ma prstup k pecilnemu obsahu strnky ako je kniha nvtev, nstenka, tovar obchodu at. Modul okrem inho ukazuje tatistiky prstupov pre jednotliv strnky.',
		'mlang_tabs_tab' => 'Strnka',
	),
	'lt' => Array (
	),
);
?>