<?php

$LOCAL_LANG = Array (
	'default' => Array (
		'welcome' => 'TYPO3 Professional Web Content Management System',
		'minor' => 'TYPO3 is a flexible and professional Open Source Web-CMS based on PHP4 and MySQL.<br><br>TYPO3 is <B>freely available</b> under the <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3-license (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'About TYPO3',
		'mlang_labels_tabdescr' => 'Displays the basic facts about the TYPO3 application, version and licensing terms.',
		'mlang_tabs_tab' => 'About',
	),
	'dk' => Array (
		'welcome' => 'TYPO3 Professionelt Web Content Management System',
		'minor' => 'TYPO3 er et flexibelt og professionelt Open Source Web-CMS baseret p PHP4 og MySQL.<br><br>TYPO3 er til <B>fri afbenyttelse</b> under <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3-licensen (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Information om TYPO3',
		'mlang_labels_tabdescr' => 'Viser grundlggende fakta omkring TYPO3 systemet, versionsnummer og licensbetingelser.',
		'mlang_tabs_tab' => 'Om TYPO3',
	),
	'de' => Array (
		'welcome' => 'TYPO3 Professionelles Web Content Managment System',
		'minor' => 'TYPO3 ist ein flexibles und professionelles Open Source Web-CMS basierend auf PHP4 und MySQL.<br><br>TYPO3 ist <b>frei verfgbar</b> unter der <a href="http://typo3.com/1244.0.html" target="_blank">TYPO3-Lizenz (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Informationen ber TYPO3',
		'mlang_labels_tabdescr' => 'Zeigt Ihnen die grundlegenden Informationen zu TYPO3, Versionsinformationen und Lizenzbedingungen an.',
		'mlang_tabs_tab' => 'ber TYPO3',
	),
	'no' => Array (
		'welcome' => 'TYPO3 profesjonelt Web Content Management System',
		'minor' => 'TYPO3 er et fleksibelt og profesjonelt Open Source Web-CMS basert p PHP4 og MySQL.<br><br>TYPO3 kan <B>fritt benyttes</b> under <A HREF="http://www.TYPO3.dk/?price_dk" target="_blank">TYPO3-lisensen (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Informasjon om TYPO3',
		'mlang_labels_tabdescr' => 'Grunnleggende informasjon om TYPO3 systemet, versjonsnummer og lisensbetingelser.',
		'mlang_tabs_tab' => 'Om TYPO3',
	),
	'it' => Array (
		'welcome' => 'TYPO3 Professional Web Content Management System',
		'minor' => 'TYPO3  un flessibile e professionale Web-CMS Open Source, basato su PHP4 e MySQL.<br><br>TYPO3  <B>liberamente disponibile</b> su <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3-license (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Notizie su TYPO3',
		'mlang_labels_tabdescr' => 'Mostra notizie di carattere generale su TYPO3, quali la versione e la licenza d\'uso.',
		'mlang_tabs_tab' => 'Notizie',
	),
	'fr' => Array (
		'welcome' => 'TYPO3 CMS Solution professionnel pour la gestion de contenu d\'un site web.',
		'minor' => 'TYPO3 est un web-CMS Opensource flexible et professionnel bas sur PHP4 et mySQL.',
		'mlang_labels_tablabel' => 'A propos de TYPO3',
		'mlang_labels_tabdescr' => 'Affiche des informations basiques sur TYPO3, version, licence, ...',
		'mlang_tabs_tab' => 'A propos',
	),
	'es' => Array (
		'welcome' => 'TYPO3 Professional Web Content Management System',
		'minor' => 'TYPO3 es un CMS flexible y profesional, con su cdigo fuente abierto, basado en PHP4 y MySQL. <br><br>TYPO3 est <B>disponible libremente</b> bajo la <A HREF="http://typo3.com/1244.0.html" target="_blank">licencia TYPO3 (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Acerca de TYPO3',
		'mlang_labels_tabdescr' => 'Muestra ',
		'mlang_tabs_tab' => 'Acerca de',
	),
	'nl' => Array (
		'welcome' => 'TYPO3 Professioneel Web Content Management Systeem',
		'minor' => 'TYPO3 is een flexibel en professioneel Open Source Web-CMS gebaseerd op PHP4 en MySQL.<br><br>TYPO3 is <b>gratis verkrijgbaar</b> onder de <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3-licentie (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Over TYPO3',
		'mlang_labels_tabdescr' => 'Toont de belangrijkste gegevens over de TYPO3 applicatie, versie en licentie bepalingen.',
		'mlang_tabs_tab' => 'Over',
	),
	'cz' => Array (
		'welcome' => 'Profesionln systm pro sprvu obsahu webu TYPO3',
		'minor' => 'TYPO3 je flexibiln a profesionln Open Source Web-CMS zaloen na PHP4 a MySQL.<br><br>TYPO3 je <b>voln dostupn</b> pod <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3-licenc GNU/GPL)</a>.<br><br>%s %s<br> ',
		'mlang_labels_tablabel' => 'O TYPO3',
		'mlang_labels_tabdescr' => 'Zobraz zkladn informace o aplikaci TYPO3, verzi a licennch podmnkch.',
		'mlang_tabs_tab' => 'O TYPO3',
	),
	'pl' => Array (
		'welcome' => 'TYPO3 Profesjonalny System do Zarzdzania Treci',
		'minor' => 'TYPO3 jest elastycznym i profesjonalnym systemem klasy Web-CMS o Otwartym Kodzie (Open Source), opartym na PHP4 i MySQL.<br><br>TYPO3 jest <b>dostpny bez opat</b> na zasadach <A HREF="http://typo3.com/1244.0.html" target="_blank">licencji TYPO3 (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Informacje o TYPO3',
		'mlang_labels_tabdescr' => 'Wywietla podstawowe informacje o TYPO3 oraz wersj i warunki licencji.',
		'mlang_tabs_tab' => 'O TYPO3',
	),
	'si' => Array (
		'welcome' => 'TYPO3 - sistem za urejanje spletne vsebine (Web CMS)',
		'minor' => 'TYPO3 je prilagodljiv profesionalen sistem za urejanje spletne vsebine. Deluje na podlagi PHP4 in  MySQL.<br><br>TYPO3 je <b>dosegljiv zastonj</b> upotevajo <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3 licenco (GNU/GPL)</a>.<br><br>TYPO3 je v slovenski jezik prevedel Andrej Blatnik, ablatnik@email.si<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'O TYPO3',
		'mlang_labels_tabdescr' => 'Prikae osnovne informacije o programu TYPO3: verzija in licenni pogoji.',
		'mlang_tabs_tab' => 'O TYPO3',
	),
	'fi' => Array (
		'welcome' => 'TYPO3 Professional Web Content Management System',
		'minor' => 'TYPO3 on joustava ja ammattimaisesti tehty avoin www-sivujen hallinta ohjelmisto.joka perustuu PHP4 ja MySQL ohjelmistoihin. <br><br>TYPO3 on <B>vapaasti saatavissa</b>, www-sivuilta <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3-lisenssin mukaisesti (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Tietoa TYPO3sta',
		'mlang_labels_tabdescr' => 'Nytt yleisi tietoja TYPO3sta',
		'mlang_tabs_tab' => 'Tietoa TYPO3sta',
	),
	'tr' => Array (
		'welcome' => 'TYPO3 Profesyonel Web erik Ynetim Sistemi',
		'minor' => 'TYPO3 PHP4 ve Mysql tabanl profesyonel ve esnek kaynak kodu ak bir Web-CMS\'dir.<br><br>TYPO3<b>serbeste elde edilebilir</b> aadaki <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3 lisans (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'TYPO3 hakknda',
		'mlang_labels_tabdescr' => 'TYPO3 bavurusu, versiyon ve lisans koullar hakknda temel olgular gsterir.',
		'mlang_tabs_tab' => 'Hakknda',
	),
	'se' => Array (
		'welcome' => 'TYPO3 Professional Web Content Management System',
		'minor' => 'TYPO3 r en flexibel och professionell Open Source Web-CMS och r baserad p PHP4 och MySQL.<br><br>TYPO3 kan <B>fritt anvndas</b> enligt villkoren i<A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3-licensen (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Om TYPO3',
		'mlang_labels_tabdescr' => 'Visar grunduppgifter om applikationen TYPO3 ssom version och licensvillkor.',
		'mlang_tabs_tab' => 'Om',
	),
	'pt' => Array (
		'welcome' => 'Typo3 Gestor de Contedos Web Profissional',
		'minor' => 'Typo3  um Web-CMS Open Source flexvel e profissional basedo no PHP4 e MySQL.<br><br>Typo3  <B>gratuitamente disponvel</b> sob a licena <A HREF="http://www.typo3.com/?price_uk" target="_blank">Typo3-license (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Acerca do Typo3',
		'mlang_labels_tabdescr' => 'Mostra os factos bsicos acerca da aplicao Typo3, verso e termos de licenciamento.',
		'mlang_tabs_tab' => 'Acerca',
	),
	'ru' => Array (
		'welcome' => '   - TYPO3',
		'minor' => 'TYPO3 -           PHP4  ySQL.<br><br>TYPO3 <B>  </b>   <A HREF="http://typo3.com/1244.0.html" target="_blank">TYPO3- (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => ' TYPO3',
		'mlang_labels_tabdescr' => '     ypo3,     ',
		'mlang_tabs_tab' => ' ',
	),
	'ro' => Array (
	),
	'ch' => Array (
		'welcome' => 'Typo3רҵվݹϵͳ',
		'minor' => 'Typo3һרҵĿԴĻPHP4MySQLվݹϵͳ.<br><br>Typo3<A HREF="http://www.typo3.com/?price_uk" target="_blank">Typo3-֤(GNU/GPL)</a><b>ɵʹ</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Typo3',
		'mlang_labels_tabdescr' => 'ʾTypo3ӦõĻΪ, 汾.',
		'mlang_tabs_tab' => '',
	),
	'sk' => Array (
		'welcome' => 'Typo3 Profesionlny systm na sprvu obsahu na webe',
		'minor' => 'Typo3 je flexibiln a profesionlny Open Source Web-CMS zaloen na PHP4 a MySQL..<br><br>Typo3 je <B>dostupn gratis</b> pod <A HREF="http://www.typo3.com/?price_uk" target="_blank">licenciou Typo3 (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'O Typo3',
		'mlang_labels_tabdescr' => 'Zobraz zkladn daje o aplikci Typo3,o jej verzi a licennch podmienkach.',
		'mlang_tabs_tab' => 'O Typo3',
	),
	'lt' => Array (
		'welcome' => 'Typo3 Profesionali Web Turinio Valdymo Sistema',
		'minor' => 'Typo3 yra lanksti ir profesionali Atviro Kodo Web-TVS sukurta PHP4 ir MySQL pagrindu.<br><br>Typo3 yra <B>laisvai platinama</B> po <A HREF="http://www.typo3.com/?price_uk" target="_blank">Typo3 licensija (GNU/GPL)</a>.<br><br>%s %s<br>',
		'mlang_labels_tablabel' => 'Apie Typo3',
		'mlang_labels_tabdescr' => 'Parodo pagrindinius faktus apie Typo3 programa, versija ir licenzijavima.',
		'mlang_tabs_tab' => 'Apie',
	),
);
?>