# MySQL dump 6.4
#
# Host: localhost    Database: t3_typo3site
#--------------------------------------------------------
# Server version	3.22.27

#
# Table structure for table 'static_dc_type'
#
DROP TABLE IF EXISTS static_dc_type;
CREATE TABLE static_dc_type (
  uid int(11) unsigned DEFAULT '0' NOT NULL auto_increment,
  pid int(11) unsigned DEFAULT '0' NOT NULL,
  tstamp int(11) unsigned DEFAULT '0' NOT NULL,
  title tinytext NOT NULL,
  description text NOT NULL,
  tmpl_a_subpart_marker tinytext NOT NULL,
  active int(11) DEFAULT '0' NOT NULL,
  tmpl_a_description text NOT NULL,
  tmpl_a_content text NOT NULL,
  tmpl_a_TSconfig text NOT NULL,
  tmpl_b_subpart_marker tinytext NOT NULL,
  tmpl_b_description text NOT NULL,
  tmpl_b_content text NOT NULL,
  tmpl_b_TSconfig text NOT NULL,
  tmpl_c_subpart_marker tinytext NOT NULL,
  tmpl_c_description text NOT NULL,
  tmpl_c_content text NOT NULL,
  tmpl_c_TSconfig text NOT NULL,
  PRIMARY KEY (uid),
  KEY parent (pid)
);

#
# Dumping data for table 'static_dc_type'
#

INSERT INTO static_dc_type VALUES (1,0,1018858874,'Guestbook','This is the template for the default guestbook. The language is english.','###TEMPLATE_GUESTBOOK###',1,'This template for the guestbook features:\r\n\r\n- A header section (the orange table cell)\r\n- A content section, which is where the guest book items go:\r\n- The content section has two alternative designs: One with a light background and one with an olive background. When listing the guestbook items, Typo3 will alternate between using the one or the other design.\r\n(See the source code for subparts and markers)\r\n','<TABLE cellpadding=\"4\" cellspacing=\"1\" border=\"0\" width=\"98%\">\r\n  <TR bgcolor=\"###GC3###\">\r\n    <TD colspan=2 valign=\"bottom\">###GW2B### <font color=\"#FFFFFF\"><B>Comments:</B></FONT>###GW2E###</TD>\r\n      </TR>\r\n<!-- ###CONTENT### begin\r\n  This is the part of the template substituted with the list of comments/entries: \r\n-->\r\n<!-- ###POST### begin \r\n  Template for a single item \r\n-->\r\n        <TR>\r\n          <TD bgcolor=\"###GC2###\" valign=\"top\">\r\n            ###GW2B### ###POST_DATE### - ###POST_TIME### - ###POST_AGE### ###GW2E###\r\n          </TD>\r\n          <TD bgcolor=\"###GC2###\" valign=\"top\">\r\n            ###GW2B### <B>###POST_AUTHOR###</B> - ###POST_EMAIL###<BR>###POST_WWW### ###GW2E###\r\n          </TD>\r\n        </TR>\r\n        <TR>\r\n          <TD bgcolor=\"###GC2###\" valign=\"top\">\r\n          </TD>\r\n          <TD bgcolor=\"###GC2###\" valign=\"top\">\r\n            ###GW1B###<B>###POST_TITLE###</B>###GW1E###<BR>\r\n            ###GW2B### ###POST_CONTENT### ###GW2E###\r\n          </TD>\r\n        </TR>\r\n<!-- ###POST### end-->\r\n<!-- ###POST_1### begin \r\n    Template for an alternative single item \r\n -->\r\n        <TR>\r\n          <TD bgcolor=\"###GC1###\" valign=\"top\">\r\n            ###GW2B### ###POST_DATE### - ###POST_TIME### - ###POST_AGE### ###GW2E###\r\n          </TD>\r\n          <TD bgcolor=\"###GC1###\" valign=\"top\">\r\n             ###GW2B### <B>###POST_AUTHOR###</B> - ###POST_EMAIL###<BR>###POST_WWW### ###GW2E###\r\n          </TD>\r\n        </TR>\r\n        <TR>\r\n          <TD bgcolor=\"###GC1###\" valign=\"top\">\r\n          </TD>\r\n          <TD bgcolor=\"###GC1###\" valign=\"top\">\r\n             ###GW1B###<B>###POST_TITLE###</B>###GW1E###<BR>\r\n             ###GW2B### ###POST_CONTENT### ###GW2E###\r\n          </TD>\r\n        </TR>\r\n<!-- ###POST_1### end-->\r\n<!-- ###CONTENT###  end -->\r\n</TABLE><BR>\r\n','','','','','','','','','');

