<?php


// ******************************************************************
// sys_dc
// ******************************************************************
$TCA["sys_dc"] = Array (
	"ctrl" => $TCA["sys_dc"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "hidden,title"
	),
	"columns" => Array (	
		"title" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.title",
			"config" => Array (
				"type" => "input",	
				"size" => "35",
				"max" => "80",
				"eval" => "trim,required"
			)
		),
		"description" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.description",
			"config" => Array (
				"type" => "text",
				"rows" => 5,
				"cols" => 48
			)
		),
		"tmpl_a_content" => Array (
			"label" => "LLL:EXT:design_components/locallang_tca.php:sys_dc.tmpl_a_content",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "10",
				"wrap" => "OFF"
			)
		),
		"tmpl_b_content" => Array (
			"label" => "LLL:EXT:design_components/locallang_tca.php:sys_dc.tmpl_b_content",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "10",
				"wrap" => "OFF"
			)
		),
		"tmpl_c_content" => Array (
			"label" => "LLL:EXT:design_components/locallang_tca.php:sys_dc.tmpl_c_content",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "10",
				"wrap" => "OFF"
			)
		),
		"component_type" => Array (
			"label" => "LLL:EXT:design_components/locallang_tca.php:sys_dc.component_type",
			"config" => Array (
				"type" => "select",
				"foreign_table" => "sys_dc_type",
				"foreign_table_where" => "ORDER BY sys_dc_type.title",
				"neg_foreign_table" => "static_dc_type",
				"neg_foreign_table_where" => "ORDER BY static_dc_type.title",
				"neg_foreign_table_prefix" => "STATIC: |STATISK: ",
				"size" => 1,
				"default" => "",
				"items" => Array(
					Array("",0)
				)
			)
		),
		"hidden" => Array (
			"label" => "LLL:EXT:lang/locallang_general.php:LGL.disable",
			"exclude" => 1,	
			"config" => Array (
				"type" => "check",
				"default" => "0"
			)
		)
	),
	"types" => Array (					
		"0" => Array("showitem" => "title;;1;;2-2-2, component_type, description"),
		"-1" => Array("showitem" => "title;;1;;2-2-2, component_type, description, tmpl_a_content;
			LLL:EXT:design_components/locallang_tca.php:sys_dc.tmpl_a_content.ALT.-1
			;;;3-3-3")
	),
	"palettes" => Array (
		"1" => Array("showitem" => "hidden"),
	)
);





// ******************************************************************
// static_dc_type
// ******************************************************************
$TCA["static_dc_type"] = Array (
	"ctrl" => $TCA["static_dc_type"]["ctrl"],
	"interface" => Array (
		"showRecordFieldList" => "hidden,title"
	),
	"columns" => Array (	
		"title" => Array (
			"label" => "Title:",
			"config" => Array (
				"type" => "input",	
				"size" => "35",
				"max" => "80",
				"eval" => "trim,required"
			)
		),
		"description" => Array (
			"label" => "General Description:",
			"config" => Array (
				"type" => "text",
				"rows" => 5,
				"cols" => 48
			)
		),
		"active" => Array (
			"label" => "Active:",
			"config" => Array (
				"type" => "check",
				"items" => array(
					Array("1",""),
					Array("2",""),
					Array("3",""),
//					Array("4",""),
				),
				"cols" => 4
			)
		),
		"tmpl_a_subpart_marker" => Array (
			"label" => "Subpart marker:",
			"config" => Array (
				"type" => "input",	
				"max" => "80",
			)
		),
		"tmpl_a_description" => Array (
			"label" => "Help text:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => 5
			)
		),
		"tmpl_a_content" => Array (
			"label" => "Template content:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "10",
				"wrap" => "OFF"
			)
		),
		"tmpl_a_TSconfig" => Array (
			"label" => "RTE TS config:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "5",
				"wrap" => "OFF"
			)
		),

		
		"tmpl_b_subpart_marker" => Array (
			"label" => "Subpart marker:",
			"config" => Array (
				"type" => "input",	
				"max" => "80",
			)
		),
		"tmpl_b_description" => Array (
			"label" => "Help text:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => 5
			)
		),
		"tmpl_b_content" => Array (
			"label" => "Template content:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "10",
				"wrap" => "OFF"
			)
		),
		"tmpl_b_TSconfig" => Array (
			"label" => "RTE TS config:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "5",
				"wrap" => "OFF"
			)
		),

		
		"tmpl_c_subpart_marker" => Array (
			"label" => "Subpart marker:",
			"config" => Array (
				"type" => "input",	
				"max" => "80",
			)
		),
		"tmpl_c_description" => Array (
			"label" => "Help text:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => 5
			)
		),
		"tmpl_c_content" => Array (
			"label" => "Template content:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "10",
				"wrap" => "OFF"
			)
		),
		"tmpl_c_TSconfig" => Array (
			"label" => "RTE TS config:",
			"config" => Array (
				"type" => "text",
				"cols" => "48",
				"rows" => "5",
				"wrap" => "OFF"
			)
		),

		
		
	),
	"types" => Array (					
		"1" => Array(
			"showitem" => "title;;;;2-2-2, description, active,
				, tmpl_a_subpart_marker;;;;3-3-3, tmpl_a_description, tmpl_a_content, tmpl_a_TSconfig
				, tmpl_b_subpart_marker;;;;3-3-3, tmpl_b_description, tmpl_b_content, tmpl_b_TSconfig
				, tmpl_c_subpart_marker;;;;3-3-3, tmpl_c_description, tmpl_c_content, tmpl_c_TSconfig
				",
			"bitmask_value_field" => "active",
			"bitmask_excludelist_bits" => Array (
				"-0" => "tmpl_a_subpart_marker,tmpl_a_description,tmpl_a_content,tmpl_a_TSconfig",
				"-1" => "tmpl_b_subpart_marker,tmpl_b_description,tmpl_b_content,tmpl_b_TSconfig",
				"-2" => "tmpl_c_subpart_marker,tmpl_c_description,tmpl_c_content,tmpl_c_TSconfig"
			)
		)
	)
);


$TCA["sys_dc_type"]=array_merge(
	$TCA["static_dc_type"],
	array("ctrl"=>$TCA["sys_dc_type"]["ctrl"])
);

?>