<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2002 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

class tx_impexp_clickmenu {
	function main(&$backRef,$menuItems,$table,$uid)	{
		global $BE_USER,$TCA;
	
		$localItems=array();
		if ($backRef->cmLevel && t3lib_div::GPvar("subname")=="moreoptions")	{

			$LL = $this->includeLL();
		
			$url = t3lib_extMgm::extRelPath("impexp").'app/index.php?tx_impexp[action]=export';
			if ($table=="pages")	{
				$url.="&tx_impexp[pagetree][id]=".$uid;
				$url.="&tx_impexp[pagetree][levels]=0";
				$url.="&tx_impexp[pagetree][tables][]=_ALL";
			} else {
				$url.="&tx_impexp[record][]=".rawurlencode($table.":".$uid);
				$url.="&tx_impexp[external_ref][tables][]=_ALL";
			}
			$localItems[] = $backRef->linkItem(
				$GLOBALS["LANG"]->getLLL("export",$LL),
				$backRef->excludeIcon('<img src="'.t3lib_extMgm::extRelPath("impexp").'export.gif" width="18" height="16" border=0 align=top>'),
				$backRef->urlRefForCM($url),
				1	// Disables the item in the top-bar
			);

			if ($table=="pages")	{
				$url = t3lib_extMgm::extRelPath("impexp").'app/index.php?id='.$uid.'&table='.$table.'&tx_impexp[action]=import';
				$localItems[] = $backRef->linkItem(
					$GLOBALS["LANG"]->getLLL("import",$LL),
					$backRef->excludeIcon('<img src="'.t3lib_extMgm::extRelPath("impexp").'import.gif" width="18" height="16" border=0 align=top>'),
					$backRef->urlRefForCM($url),
					1	// Disables the item in the top-bar
				);
			}
		}
		return array_merge($menuItems,$localItems);
	}
	function includeLL()	{
		include(t3lib_extMgm::extPath("impexp")."app/locallang.php");
		return $LOCAL_LANG;
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/impexp/class.tx_impexp_clickmenu.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/impexp/class.tx_impexp_clickmenu.php"]);
}

?>