<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * RTE language
 *
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

#define("TYPO3_MOD_PATH","ext/rte/");		// Relative path to the module from the typo3/ folder
#$BACK_PATH="../../";					// Relative path to the typo3/ folder
#require ($BACK_PATH."init.php");
#require ($BACK_PATH."template.php");


error_reporting (E_ALL ^ E_NOTICE); 
include ("./locallang.php");


function slashJS($string,$extended=0,$char="'")	{
	if ($extended)	{$string = str_replace ("\\", "\\\\", $string);}
	return str_replace ($char, "\\".$char, $string);
}	

	
if (is_array($LOCAL_LANG["default"]))	{
	$lang = $GLOBALS["HTTP_GET_VARS"]["lang"];
	if ($lang && is_array($LOCAL_LANG[$lang]))	{
		$LOCAL_LANG["default"] = array_merge($LOCAL_LANG["default"],$LOCAL_LANG[$lang]);
	}
	reset($LOCAL_LANG["default"]);
	while(list($key,$label)=each($LOCAL_LANG["default"]))	{
		echo 'var '.$key.' = "'.slashJS(htmlspecialchars($label),1,'"').'";'.chr(10);
	}
}

?>
