<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 1999-2003 Kasper Skrhj (kasper@typo3.com)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license 
*  from the author is found in LICENSE.txt distributed with these scripts.
*
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * @author	Kasper Skrhj <kasper@typo3.com>
 */

require_once(PATH_t3lib."class.t3lib_page.php");
require_once(PATH_t3lib."class.t3lib_tcemain.php");

require_once(PATH_t3lib."class.t3lib_extobjbase.php");

class tx_wizardcrpages_webfunc_2 extends t3lib_extobjbase {
	var $localLangFile = "locallang.php";

	function modMenu()	{
		global $LANG;
		
		$modMenuAdd = array(
			"cr_333" => array(
				"0" => "nul",
				"1" => "et"
			)
		);
		return $modMenuAdd;
	}
	function main()	{
		global $SOBE,$LANG;

		$theCode="";

		$m_perms_clause = $GLOBALS["BE_USER"]->getPagePermsClause(8);	// create new pages here?
		$pRec = t3lib_BEfunc::getRecord ("pages",$this->pObj->id,"uid"," AND ".$m_perms_clause);
		$sys_pages = t3lib_div::makeInstance("t3lib_pageSelect");
		$menuItems = $sys_pages->getMenu($this->pObj->id);
		if (is_array($pRec))	{
			$data = t3lib_div::GPvar("data");
			if (is_array($data["pages"]))	{
				if (t3lib_div::GPvar("createInListEnd"))	{
					$endI = end($menuItems);
					$thePid = -intval($endI["uid"]);
					if (!$thePid)	$thePid = $this->pObj->id;
				} else {
					$thePid = $this->pObj->id;
				}
//				debug($thePid);
					// Save
//				reset($data["pages"]);
				while(list($k,$dat)=each($data["pages"]))	{
					if (!trim($dat["title"]))	{
						unset($data["pages"][$k]);
					} else {
						$data["pages"][$k]["pid"]=$thePid;
						$data["pages"][$k]["hidden"] = t3lib_div::GPvar("hidePages") ? 1 : 0;
					}
				}
				if (count($data["pages"]))	{
					reset($data);
					$tce = t3lib_div::makeInstance("t3lib_TCEmain");
					$tce->reverseOrder=1;
					$tce->start($data,array());
					$tce->process_datamap();
					t3lib_BEfunc::getSetUpdateSignal("updatePageTree");
				} else {
					$theCode.=rfw($LANG->getLL("wiz_newPages_noCreate")."<BR><BR>");
				}
//						debug($data);
				
					// Display result:
				$menuItems = $sys_pages->getMenu($this->pObj->id);
				reset($menuItems);
				$lines=array();
				while(list(,$rec)=each($menuItems))	{
					$lines[]= '<nobr>'.t3lib_iconWorks::getIconImage("pages",$rec,$GLOBALS["BACK_PATH"],'align=top '.t3lib_BEfunc::titleAttribForPages($rec)).
						htmlspecialchars(t3lib_div::fixed_lgd($rec["title"],$GLOBALS["BE_USER"]->uc["titleLen"])).'</nobr>';
				}
				$theCode.= '<B>'.$LANG->getLL("wiz_newPages_currentMenu").':</B><BR><BR>'.implode("<BR>",$lines);
			} else {
					// Display create form:
				$lines=array();
				for ($a=0;$a<9;$a++)	{
					$lines[]=$LANG->getLL("wiz_newPages_page").' '.($a+1).': <input type="text" name="data[pages][NEW'.$a.'][title]"'.$this->pObj->doc->formWidth(35).'>';
				}
				
				$theCode.= '<B>'.$LANG->getLL("wiz_newPages").':</B><BR><BR>'.implode("<BR>",$lines).
				'<BR><BR>
				<input type="checkbox" name="createInListEnd" value="1">'.$LANG->getLL("wiz_newPages_listEnd").'<BR>
				<input type="checkbox" name="hidePages" value="1">'.$LANG->getLL("wiz_newPages_hidePages").'<BR>
				<input type="submit" name="create" value="'.$LANG->getLL("wiz_newPages_lCreate").'" onClick="return confirm(unescape(\''.rawurlencode($GLOBALS["LANG"]->getLL("wiz_newPages_lCreate_msg1")).'\'))"> <input type="Reset" value="'.$LANG->getLL("wiz_newPages_lReset").'">';
				
					// Help text:
				if ($GLOBALS["BE_USER"]->uc["helpText"])	{
					$theCode.= '<BR><BR>'.$this->helpBubble().$LANG->getLL("wiz_newPages_helpText");
				}
			}
		} else {
			$theCode.=rfw($LANG->getLL("wiz_newPages_errorMsg1"));
		}

		$out=$this->pObj->doc->section($LANG->getLL("wiz_crMany"),$theCode,0,1);
		return $out;
	}
	function helpBubble()	{
		return '<img src="'.$GLOBALS["BACK_PATH"].'gfx/helpbubble.gif" width="14" height="14" hspace=2 align=top'.$this->pObj->doc->helpStyle().'>';
	}
}

if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/wizard_crpages/class.tx_wizardcrpages_webfunc_2.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/wizard_crpages/class.tx_wizardcrpages_webfunc_2.php"]);
}

?>